From: Ratchanan Srirattanamet <ratchanan@ubports.com>
Date: Thu, 7 Dec 2023 17:58:44 +0700
Subject: adbd: allows overriding ro.adb.secure on env

Generic Halium images are built in userdebug with ro.adb.secure equals
to 0 by default. Porters that wish to enable secure ADB could enable it
using halium.prop, but we're steping away from using Android property as
a settings store. So, allow using environment variable to also enabling
secure ADB mode.

[ratchanan@ubports.com: forward-port to 14.0.0+r45]
---
 daemon/main.cpp | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

diff --git a/daemon/main.cpp b/daemon/main.cpp
index 0d94c25..87c83f7 100644
--- a/daemon/main.cpp
+++ b/daemon/main.cpp
@@ -183,6 +183,7 @@ int adbd_main(int server_port) {
 #if defined(__ANDROID__)
     bool device_unlocked = android::base::GetProperty("ro.boot.verifiedbootstate", "") == "orange";
     if (device_unlocked || __android_log_is_debuggable()) {
+#endif
 #if defined(__ANDROID_RECOVERY__)
         auth_required = false;  // Bypass authorization when the device transitions to
         // fastbootd (from recovery). A corrupt userdata image can potentially
@@ -191,8 +192,14 @@ int adbd_main(int server_port) {
         // need for manual intervention(b/188703874).
 #else
         // If we're on userdebug/eng or the device is unlocked, permit no-authentication.
-        auth_required = android::base::GetBoolProperty("ro.adb.secure", false);
+        if (const char * secure_env = getenv("ADBD_SECURE")) {
+            std::string secure = secure_env;
+            auth_required = (secure == "true" || secure == "1");
+        } else {
+            auth_required = android::base::GetBoolProperty("ro.adb.secure", false);
+        }
 #endif
+#if defined(__ANDROID__)
     }
 #endif
 
